include:
  - project: 'apc/common/gitlab-ci-utils'
    file: 'ci/scripts/gitlab-ci-susoft.yml'

##################
# LINUX BUILDS   #
##################

# Build all targets and run the tests
linux_build_and_test:
    extends: .linux_build_and_test
    # For graphical tests
    services: 
        - comiq/xvfb
    script:
        - echo "Building all targets | -j$(nproc)"
        - $CMAKEBIN --build . -j $(nproc) --config Release
        - echo "Running the tests"
        - ctest3 -V -C Release

# Build and upload the application
linux_release:
    extends: .linux_release
    script:
        - echo "Building executable | -j$(nproc)"
        - $CMAKEBIN --build . -j $(nproc) --config Release --target QScintilla
        - cd ../qscintilla/ # go to the binary dir 
        - echo -e "For info about the following, check Gitlab CI documentation:\nhttps://docs.gitlab.com/ee/ci/variables/predefined_variables.html\n" > buildinfo.txt
        - echo -e "CI_COMMIT_SHA $CI_COMMIT_SHA" >> buildinfo.txt
        - echo -e "CI_COMMIT_TITLE $CI_COMMIT_TITLE" >> buildinfo.txt
        - echo -e "CI_COMMIT_REF_NAME $CI_COMMIT_REF_NAME" >> buildinfo.txt
        - echo -e "CI_JOB_ID $CI_JOB_ID" >> buildinfo.txt
        - echo -e "CI_JOB_NAME $CI_JOB_NAME" >> buildinfo.txt
        - echo -e "CI_JOB_URL $CI_JOB_URL" >> buildinfo.txt
        - echo -e "CI_PIPELINE_ID $CI_PIPELINE_ID" >> buildinfo.txt
        - echo -e "CI_PIPELINE_SOURCE $CI_PIPELINE_SOURCE" >> buildinfo.txt
        - echo -e "CI_PIPELINE_URL $CI_PIPELINE_URL" >> buildinfo.txt
        - echo -e "CI_PROJECT_ID $CI_PROJECT_ID" >> buildinfo.txt
        - echo -e "CI_PROJECT_NAME $CI_PROJECT_NAME" >> buildinfo.txt
        - echo -e "CI_PROJECT_URL $CI_PROJECT_URL" >> buildinfo.txt
        - echo -e "GITLAB_USER_EMAIL $GITLAB_USER_EMAIL" >> buildinfo.txt
        - echo -e "GITLAB_USER_NAME $GITLAB_USER_NAME" >> buildinfo.txt
        - cd bin/
        - sha512sum *qscintilla* > sha512sum.txt
    artifacts:
        name: liblinux
        paths:
            - qscintilla/*

##################
# WINDOWS BUILDS #
##################

# Build all targets and run the tests
windows64_build_and_test:
    extends: .windows64_build_and_test

# Build and upload the application
windows64_release:
    extends: .windows64_release
    script:
        - echo "Building DEBUG executable"
        - cmake --build . -j %NUMBER_OF_PROCESSORS% --config Debug --target QScintilla
        - echo "Building RELEASE executable"
        - cmake --build . -j %NUMBER_OF_PROCESSORS% --config Release --target QScintilla
        - cd ../qscintilla/ # go to the binary dir 
        - bash -c 'echo -e "For info about the following, check Gitlab CI documentation:\nhttps://docs.gitlab.com/ee/ci/variables/predefined_variables.html\n" > buildinfo.txt '
        - bash -c 'echo -e "CI_COMMIT_SHA $CI_COMMIT_SHA" >> buildinfo.txt '
        - bash -c 'echo -e "CI_COMMIT_TITLE $CI_COMMIT_TITLE" >> buildinfo.txt '
        - bash -c 'echo -e "CI_COMMIT_REF_NAME $CI_COMMIT_REF_NAME" >> buildinfo.txt '
        - bash -c 'echo -e "CI_JOB_ID $CI_JOB_ID" >> buildinfo.txt '
        - bash -c 'echo -e "CI_JOB_NAME $CI_JOB_NAME" >> buildinfo.txt '
        - bash -c 'echo -e "CI_JOB_URL $CI_JOB_URL" >> buildinfo.txt '
        - bash -c 'echo -e "CI_PIPELINE_ID $CI_PIPELINE_ID" >> buildinfo.txt '
        - bash -c 'echo -e "CI_PIPELINE_SOURCE $CI_PIPELINE_SOURCE" >> buildinfo.txt '
        - bash -c 'echo -e "CI_PIPELINE_URL $CI_PIPELINE_URL" >> buildinfo.txt '
        - bash -c 'echo -e "CI_PROJECT_ID $CI_PROJECT_ID" >> buildinfo.txt '
        - bash -c 'echo -e "CI_PROJECT_NAME $CI_PROJECT_NAME" >> buildinfo.txt '
        - bash -c 'echo -e "CI_PROJECT_URL $CI_PROJECT_URL" >> buildinfo.txt '
        - bash -c 'echo -e "GITLAB_USER_EMAIL $GITLAB_USER_EMAIL" >> buildinfo.txt '
        - bash -c 'echo -e "GITLAB_USER_NAME $GITLAB_USER_NAME" >> buildinfo.txt '
        - cd bin/
        - sha512sum *qscintilla* > sha512sum.txt
    artifacts:
        name: libwin64
        paths:
            - qscintilla/*
